
package net.mcreator.scatteredkingdoms.entity;

import org.apache.logging.log4j.core.Core;

import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.fml.network.FMLPlayMessages;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.world.gen.Heightmap;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.DamageSource;
import net.minecraft.item.SpawnEggItem;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.Item;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.monster.MonsterEntity;
import net.minecraft.entity.ai.goal.WaterAvoidingRandomWalkingGoal;
import net.minecraft.entity.ai.goal.NearestAttackableTargetGoal;
import net.minecraft.entity.ai.goal.MeleeAttackGoal;
import net.minecraft.entity.ai.goal.LookRandomlyGoal;
import net.minecraft.entity.ai.goal.HurtByTargetGoal;
import net.minecraft.entity.ai.goal.FollowMobGoal;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.EntityType;
import net.minecraft.entity.EntitySpawnPlacementRegistry;
import net.minecraft.entity.EntityClassification;
import net.minecraft.entity.Entity;
import net.minecraft.entity.CreatureAttribute;
import net.minecraft.client.renderer.model.ModelBox;
import net.minecraft.client.renderer.entity.model.RendererModel;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.scatteredkingdoms.procedures.FrostjawPlayerCollidesWithThisEntityProcedure;
import net.mcreator.scatteredkingdoms.item.PermafrostItem;
import net.mcreator.scatteredkingdoms.ScatteredKingdomsElements;

@ScatteredKingdomsElements.ModElement.Tag
public class FrostjawEntity extends ScatteredKingdomsElements.ModElement {
	public static EntityType entity = null;
	public FrostjawEntity(ScatteredKingdomsElements instance) {
		super(instance, 9);
		FMLJavaModLoadingContext.get().getModEventBus().register(this);
	}

	@Override
	public void initElements() {
		entity = (EntityType.Builder.<CustomEntity>create(CustomEntity::new, EntityClassification.MONSTER).setShouldReceiveVelocityUpdates(true)
				.setTrackingRange(50).setUpdateInterval(3).setCustomClientFactory(CustomEntity::new).size(2f, 0.52f)).build("frostjaw")
						.setRegistryName("frostjaw");
		elements.entities.add(() -> entity);
		elements.items.add(() -> new SpawnEggItem(entity, -16751002, -1, new Item.Properties().group(ItemGroup.MISC)).setRegistryName("frostjaw"));
	}

	@Override
	public void init(FMLCommonSetupEvent event) {
		for (Biome biome : ForgeRegistries.BIOMES.getValues()) {
			boolean biomeCriteria = false;
			if (ForgeRegistries.BIOMES.getKey(biome).equals(new ResourceLocation("snowy_tundra")))
				biomeCriteria = true;
			if (ForgeRegistries.BIOMES.getKey(biome).equals(new ResourceLocation("snowy_mountains")))
				biomeCriteria = true;
			if (ForgeRegistries.BIOMES.getKey(biome).equals(new ResourceLocation("ice_spikes")))
				biomeCriteria = true;
			if (!biomeCriteria)
				continue;
			biome.getSpawns(EntityClassification.MONSTER).add(new Biome.SpawnListEntry(entity, 5, 1, 2));
		}
		EntitySpawnPlacementRegistry.register(entity, EntitySpawnPlacementRegistry.PlacementType.ON_GROUND, Heightmap.Type.MOTION_BLOCKING_NO_LEAVES,
				MonsterEntity::func_223315_a);
	}

	@SubscribeEvent
	@OnlyIn(Dist.CLIENT)
	public void registerModels(ModelRegistryEvent event) {
		RenderingRegistry.registerEntityRenderingHandler(CustomEntity.class, renderManager -> {
			return new MobRenderer(renderManager, new Modelcustom_model(), 0.5f) {
				protected ResourceLocation getEntityTexture(Entity entity) {
					return new ResourceLocation("scatteredkingdoms:textures/frostjawtexture.png");
				}
			};
		});
	}
	public static class CustomEntity extends MonsterEntity {
		public CustomEntity(FMLPlayMessages.SpawnEntity packet, World world) {
			this(entity, world);
		}

		public CustomEntity(EntityType<CustomEntity> type, World world) {
			super(type, world);
			experienceValue = 40;
			setNoAI(false);
			enablePersistence();
		}

		@Override
		protected void registerGoals() {
			super.registerGoals();
			this.targetSelector.addGoal(1, new HurtByTargetGoal(this));
			this.goalSelector.addGoal(2, new MeleeAttackGoal(this, 1, true));
			this.targetSelector.addGoal(3, new NearestAttackableTargetGoal(this, PlayerEntity.class, true, false));
			this.goalSelector.addGoal(4, new FollowMobGoal(this, (float) 0.8, 20, 5));
			this.goalSelector.addGoal(5, new WaterAvoidingRandomWalkingGoal(this, 0.8));
			this.goalSelector.addGoal(6, new LookRandomlyGoal(this));
		}

		@Override
		public CreatureAttribute getCreatureAttribute() {
			return CreatureAttribute.UNDEFINED;
		}

		@Override
		public boolean canDespawn(double distanceToClosestPlayer) {
			return false;
		}

		protected void dropSpecialItems(DamageSource source, int looting, boolean recentlyHitIn) {
			super.dropSpecialItems(source, looting, recentlyHitIn);
			this.entityDropItem(new ItemStack(PermafrostItem.block, (int) (1)));
		}

		@Override
		public net.minecraft.util.SoundEvent getAmbientSound() {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("scatteredkingdoms:frostjawambient"));
		}

		@Override
		public net.minecraft.util.SoundEvent getHurtSound(DamageSource ds) {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("scatteredkingdoms:frostjawhurt"));
		}

		@Override
		public net.minecraft.util.SoundEvent getDeathSound() {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.generic.death"));
		}

		@Override
		protected float getSoundVolume() {
			return 1.0F;
		}

		@Override
		public boolean attackEntityFrom(DamageSource source, float amount) {
			if (source == DamageSource.FALL)
				return false;
			return super.attackEntityFrom(source, amount);
		}

		@Override
		public void onCollideWithPlayer(PlayerEntity entity) {
			super.onCollideWithPlayer(entity);
			int x = (int) this.posX;
			int y = (int) this.posY;
			int z = (int) this.posZ;
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("entity", entity);
				FrostjawPlayerCollidesWithThisEntityProcedure.executeProcedure($_dependencies);
			}
		}

		@Override
		protected void registerAttributes() {
			super.registerAttributes();
			if (this.getAttribute(SharedMonsterAttributes.ARMOR) != null)
				this.getAttribute(SharedMonsterAttributes.ARMOR).setBaseValue(0);
			if (this.getAttribute(SharedMonsterAttributes.MOVEMENT_SPEED) != null)
				this.getAttribute(SharedMonsterAttributes.MOVEMENT_SPEED).setBaseValue(0.25);
			if (this.getAttribute(SharedMonsterAttributes.MAX_HEALTH) != null)
				this.getAttribute(SharedMonsterAttributes.MAX_HEALTH).setBaseValue(40);
			if (this.getAttribute(SharedMonsterAttributes.ATTACK_DAMAGE) != null)
				this.getAttribute(SharedMonsterAttributes.ATTACK_DAMAGE).setBaseValue(8);
		}
	}

	// Made with Blockbench
	// Paste this code into your mod.
	// Make sure to generate all required imports
	public static class Modelcustom_model extends EntityModel<Entity> {
		private final RendererModel head;
		private final RendererModel Jaw;
		private final RendererModel Horn3;
		private final RendererModel Horn2;
		private final RendererModel Horn1;
		private final RendererModel body;
		private final RendererModel frontleft;
		private final RendererModel frontright;
		private final RendererModel hindright;
		private final RendererModel hindleft;
		private final RendererModel tail;
		private final RendererModel bone2;
		private final RendererModel bone;
		private final RendererModel Core;
		public Modelcustom_model() {
			textureWidth = 128;
			textureHeight = 128;
			head = new RendererModel(this);
			head.setRotationPoint(0.0F, -2.0F, -15.0F);
			setRotationAngle(head, 0.6109F, 0.0F, 0.0F);
			head.cubeList.add(new ModelBox(head, 59, 0, -5.5F, -3.1808F, -13.5736F, 11, 10, 14, 0.0F, false));
			Jaw = new RendererModel(this);
			Jaw.setRotationPoint(0.0F, 3.2793F, -3.4575F);
			head.addChild(Jaw);
			Jaw.cubeList.add(new ModelBox(Jaw, 66, 46, -6.0F, -1.5762F, -10.656F, 12, 5, 9, 0.0F, false));
			Horn3 = new RendererModel(this);
			Horn3.setRotationPoint(-4.0F, -5.0F, -1.0F);
			setRotationAngle(Horn3, -0.8727F, 0.0F, -0.3491F);
			head.addChild(Horn3);
			Horn3.cubeList.add(new ModelBox(Horn3, 0, 46, -2.5261F, -7.66F, -0.7988F, 2, 12, 1, 0.0F, false));
			Horn2 = new RendererModel(this);
			Horn2.setRotationPoint(4.0F, -4.0F, -1.0F);
			setRotationAngle(Horn2, -0.8727F, 0.0F, 0.3491F);
			head.addChild(Horn2);
			Horn2.cubeList.add(new ModelBox(Horn2, 6, 46, 0.5261F, -8.66F, -0.7988F, 2, 12, 1, 0.0F, false));
			Horn1 = new RendererModel(this);
			Horn1.setRotationPoint(0.0F, -5.0107F, -6.6907F);
			setRotationAngle(Horn1, -0.2618F, 0.0F, 0.0F);
			head.addChild(Horn1);
			Horn1.cubeList.add(new ModelBox(Horn1, 12, 46, -1.0F, -3.5816F, -5.673F, 2, 7, 1, 0.0F, false));
			body = new RendererModel(this);
			body.setRotationPoint(0.0F, 0.0F, -28.0F);
			body.cubeList.add(new ModelBox(body, 0, 0, -7.0F, -3.0F, 13.0F, 14, 15, 31, 0.0F, false));
			frontleft = new RendererModel(this);
			frontleft.setRotationPoint(3.0F, 9.0F, -10.5F);
			frontleft.cubeList.add(new ModelBox(frontleft, 46, 78, 0.0F, -2.0F, -2.5F, 5, 17, 5, 0.0F, false));
			frontright = new RendererModel(this);
			frontright.setRotationPoint(-3.0F, 9.0F, -10.5F);
			frontright.cubeList.add(new ModelBox(frontright, 26, 78, -5.0F, -2.0F, -2.5F, 5, 17, 5, 0.0F, false));
			hindright = new RendererModel(this);
			hindright.setRotationPoint(3.0F, 6.0F, 12.0F);
			hindright.cubeList.add(new ModelBox(hindright, 0, 73, -1.0F, -2.0F, -3.0F, 7, 20, 6, 0.0F, false));
			hindleft = new RendererModel(this);
			hindleft.setRotationPoint(-3.0F, 6.0F, 12.0F);
			hindleft.cubeList.add(new ModelBox(hindleft, 0, 0, -6.0F, -2.0F, -3.0F, 7, 20, 6, 0.0F, false));
			tail = new RendererModel(this);
			tail.setRotationPoint(0.0F, 4.0F, 15.0F);
			setRotationAngle(tail, -0.3491F, 0.0F, 0.0F);
			tail.cubeList.add(new ModelBox(tail, 0, 46, -4.0F, -4.658F, -0.9397F, 8, 8, 19, 0.0F, false));
			bone2 = new RendererModel(this);
			bone2.setRotationPoint(0.0F, 0.342F, 17.0603F);
			setRotationAngle(bone2, -0.1745F, 0.0F, 0.0F);
			tail.addChild(bone2);
			bone2.cubeList.add(new ModelBox(bone2, 35, 54, -3.0F, -3.0898F, -3.1342F, 6, 5, 19, 0.0F, false));
			bone = new RendererModel(this);
			bone.setRotationPoint(0.0F, -1.0F, 16.0F);
			setRotationAngle(bone, 0.0873F, 0.0F, 0.0F);
			bone2.addChild(bone);
			bone.cubeList.add(new ModelBox(bone, 66, 66, -2.0F, -1.0933F, -7.4295F, 4, 3, 19, 0.0F, false));
			Core = new RendererModel(this);
			Core.setRotationPoint(0.0F, 4.0F, 0.0F);
			Core.cubeList.add(new ModelBox(Core, 90, 33, -3.0F, -3.0F, -3.0F, 6, 6, 6, 0.0F, false));
		}

		@Override
		public void render(Entity entity, float f, float f1, float f2, float f3, float f4, float f5) {
			head.render(f5);
			body.render(f5);
			frontleft.render(f5);
			frontright.render(f5);
			hindright.render(f5);
			hindleft.render(f5);
			tail.render(f5);
			Core.render(f5);
		}

		public void setRotationAngle(RendererModel modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4, float f5) {
			super.setRotationAngles(e, f, f1, f2, f3, f4, f5);
			this.Jaw.rotateAngleX = MathHelper.cos(f * 0.6662F) * f1;
			this.frontright.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.tail.rotateAngleZ = MathHelper.cos(f * 0.6662F) * f1;
			this.bone.rotateAngleZ = MathHelper.cos(f * 0.6662F) * f1;
			this.hindleft.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.head.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.head.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.hindright.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.bone2.rotateAngleZ = MathHelper.cos(f * 0.6662F + (float) Math.PI) * f1;
			this.frontleft.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.Core.rotateAngleY = f2 / 20.f;
		}
	}
}
