
package net.mcreator.scatteredkingdoms.entity;

import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.fml.network.FMLPlayMessages;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.world.World;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.DamageSource;
import net.minecraft.particles.ParticleTypes;
import net.minecraft.item.SpawnEggItem;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.Item;
import net.minecraft.entity.passive.IronGolemEntity;
import net.minecraft.entity.ai.goal.WaterAvoidingRandomWalkingGoal;
import net.minecraft.entity.ai.goal.RandomWalkingGoal;
import net.minecraft.entity.ai.goal.NearestAttackableTargetGoal;
import net.minecraft.entity.ai.goal.LeapAtTargetGoal;
import net.minecraft.entity.ai.goal.HurtByTargetGoal;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.MobEntity;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.EntityType;
import net.minecraft.entity.EntityClassification;
import net.minecraft.entity.Entity;
import net.minecraft.entity.CreatureAttribute;
import net.minecraft.client.renderer.model.ModelBox;
import net.minecraft.client.renderer.entity.model.RendererModel;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.scatteredkingdoms.procedures.StoneGolemEntityDiesProcedure;
import net.mcreator.scatteredkingdoms.procedures.BoomAfter3Procedure;
import net.mcreator.scatteredkingdoms.ScatteredKingdomsElements;

import java.util.Random;

@ScatteredKingdomsElements.ModElement.Tag
public class StoneGolemEntity extends ScatteredKingdomsElements.ModElement {
	public static EntityType entity = null;
	public StoneGolemEntity(ScatteredKingdomsElements instance) {
		super(instance, 7);
		FMLJavaModLoadingContext.get().getModEventBus().register(this);
	}

	@Override
	public void initElements() {
		entity = (EntityType.Builder.<CustomEntity>create(CustomEntity::new, EntityClassification.MONSTER).setShouldReceiveVelocityUpdates(true)
				.setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(CustomEntity::new).size(0.9f, 0.9f)).build("stonegolem")
						.setRegistryName("stonegolem");
		elements.entities.add(() -> entity);
		elements.items
				.add(() -> new SpawnEggItem(entity, -13421773, -10092544, new Item.Properties().group(ItemGroup.MISC)).setRegistryName("stonegolem"));
	}

	@SubscribeEvent
	@OnlyIn(Dist.CLIENT)
	public void registerModels(ModelRegistryEvent event) {
		RenderingRegistry.registerEntityRenderingHandler(CustomEntity.class, renderManager -> {
			return new MobRenderer(renderManager, new stonegolem(), 0.5f) {
				protected ResourceLocation getEntityTexture(Entity entity) {
					return new ResourceLocation("scatteredkingdoms:textures/textureforstonegolem.png");
				}
			};
		});
	}
	public static class CustomEntity extends IronGolemEntity {
		public CustomEntity(FMLPlayMessages.SpawnEntity packet, World world) {
			this(entity, world);
		}

		public CustomEntity(EntityType<CustomEntity> type, World world) {
			super(type, world);
			experienceValue = 5;
			setNoAI(false);
		}

		@Override
		protected void registerGoals() {
			super.registerGoals();
			this.goalSelector.addGoal(1, new RandomWalkingGoal(this, 0.8));
			this.goalSelector.addGoal(2, new WaterAvoidingRandomWalkingGoal(this, 0.8));
			this.goalSelector.addGoal(3, new LeapAtTargetGoal(this, (float) 0.5));
			this.targetSelector.addGoal(4, new HurtByTargetGoal(this).setCallsForHelp(this.getClass()));
			this.targetSelector.addGoal(5, new NearestAttackableTargetGoal(this, MobEntity.class, false, false));
		}

		@Override
		public CreatureAttribute getCreatureAttribute() {
			return CreatureAttribute.UNDEFINED;
		}

		protected void dropSpecialItems(DamageSource source, int looting, boolean recentlyHitIn) {
			super.dropSpecialItems(source, looting, recentlyHitIn);
		}

		@Override
		public net.minecraft.util.SoundEvent getAmbientSound() {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation(""));
		}

		@Override
		public net.minecraft.util.SoundEvent getHurtSound(DamageSource ds) {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("block.shulker_box.open"));
		}

		@Override
		public net.minecraft.util.SoundEvent getDeathSound() {
			return (net.minecraft.util.SoundEvent) ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("block.stone.hit"));
		}

		@Override
		protected float getSoundVolume() {
			return 1.0F;
		}

		@Override
		public void onDeath(DamageSource source) {
			super.onDeath(source);
			int x = (int) this.posX;
			int y = (int) this.posY;
			int z = (int) this.posZ;
			Entity entity = this;
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("x", x);
				$_dependencies.put("y", y);
				$_dependencies.put("z", z);
				$_dependencies.put("world", world);
				StoneGolemEntityDiesProcedure.executeProcedure($_dependencies);
			}
		}

		@Override
		public void onKillEntity(LivingEntity entity) {
			super.onKillEntity(entity);
			int x = (int) this.posX;
			int y = (int) this.posY;
			int z = (int) this.posZ;
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("x", x);
				$_dependencies.put("y", y);
				$_dependencies.put("z", z);
				$_dependencies.put("world", world);
				BoomAfter3Procedure.executeProcedure($_dependencies);
			}
		}

		@Override
		protected void registerAttributes() {
			super.registerAttributes();
			if (this.getAttribute(SharedMonsterAttributes.ARMOR) != null)
				this.getAttribute(SharedMonsterAttributes.ARMOR).setBaseValue(0);
			if (this.getAttribute(SharedMonsterAttributes.MOVEMENT_SPEED) != null)
				this.getAttribute(SharedMonsterAttributes.MOVEMENT_SPEED).setBaseValue(0.3);
			if (this.getAttribute(SharedMonsterAttributes.MAX_HEALTH) != null)
				this.getAttribute(SharedMonsterAttributes.MAX_HEALTH).setBaseValue(10);
			if (this.getAttribute(SharedMonsterAttributes.ATTACK_DAMAGE) != null)
				this.getAttribute(SharedMonsterAttributes.ATTACK_DAMAGE).setBaseValue(5);
		}

		public void livingTick() {
			super.livingTick();
			int i = (int) this.posX;
			int j = (int) this.posY;
			int k = (int) this.posZ;
			Random random = this.rand;
			if (true)
				for (int l = 0; l < 5; ++l) {
					double d0 = (i + random.nextFloat());
					double d1 = (j + random.nextFloat());
					double d2 = (k + random.nextFloat());
					int i1 = random.nextInt(2) * 2 - 1;
					double d3 = (random.nextFloat() - 0.5D) * 0.8000000014901161D;
					double d4 = (random.nextFloat() - 0.5D) * 0.8000000014901161D;
					double d5 = (random.nextFloat() - 0.5D) * 0.8000000014901161D;
					world.addParticle(ParticleTypes.ENCHANT, d0, d1, d2, d3, d4, d5);
				}
		}
	}

	// Made with Blockbench
	// Paste this code into your mod.
	// Make sure to generate all required imports
	public static class stonegolem extends EntityModel<Entity> {
		private final RendererModel body;
		private final RendererModel rightleg;
		private final RendererModel rightarm;
		private final RendererModel leftarm;
		private final RendererModel head;
		private final RendererModel leftleg;
		private final RendererModel ore;
		public stonegolem() {
			textureWidth = 64;
			textureHeight = 64;
			body = new RendererModel(this);
			body.setRotationPoint(0.0F, 5.0F, 0.0F);
			body.cubeList.add(new ModelBox(body, 0, 16, -3.0F, -4.0F, -4.0F, 7, 7, 7, 0.0F, false));
			body.cubeList.add(new ModelBox(body, 24, 26, -4.0F, -5.0F, -2.0F, 8, 12, 4, 0.0F, false));
			rightleg = new RendererModel(this);
			rightleg.setRotationPoint(-3.0F, 12.0F, 0.0F);
			rightleg.cubeList.add(new ModelBox(rightleg, 12, 42, -1.0F, 0.0F, -2.0F, 4, 12, 4, 0.0F, false));
			rightarm = new RendererModel(this);
			rightarm.setRotationPoint(-6.0F, 3.0F, 0.0F);
			rightarm.cubeList.add(new ModelBox(rightarm, 28, 42, -2.0F, -3.0F, -2.0F, 4, 12, 4, 0.0F, false));
			leftarm = new RendererModel(this);
			leftarm.setRotationPoint(4.0F, 2.0F, 0.0F);
			leftarm.cubeList.add(new ModelBox(leftarm, 0, 30, 0.0F, -2.0F, -2.0F, 4, 12, 4, 0.0F, false));
			head = new RendererModel(this);
			head.setRotationPoint(0.0F, 0.0F, 0.0F);
			head.cubeList.add(new ModelBox(head, 0, 0, -4.0F, -8.0F, -4.0F, 8, 8, 8, 0.0F, false));
			leftleg = new RendererModel(this);
			leftleg.setRotationPoint(2.0F, 12.0F, 0.0F);
			leftleg.cubeList.add(new ModelBox(leftleg, 32, 0, -2.0F, 0.0F, -2.0F, 4, 12, 4, 0.0F, false));
			ore = new RendererModel(this);
			ore.setRotationPoint(0.0F, 6.0F, 0.0F);
			ore.cubeList.add(new ModelBox(ore, 44, 12, -15.0F, -1.0F, 6.0F, 4, 4, 4, 0.0F, false));
			ore.cubeList.add(new ModelBox(ore, 44, 44, -3.0F, 2.0F, -15.0F, 4, 4, 4, 0.0F, false));
			ore.cubeList.add(new ModelBox(ore, 28, 16, 7.0F, -7.0F, 6.0F, 4, 4, 4, 0.0F, false));
		}

		@Override
		public void render(Entity entity, float f, float f1, float f2, float f3, float f4, float f5) {
			body.render(f5);
			rightleg.render(f5);
			rightarm.render(f5);
			leftarm.render(f5);
			head.render(f5);
			leftleg.render(f5);
			ore.render(f5);
		}

		public void setRotationAngle(RendererModel modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4, float f5) {
			super.setRotationAngles(e, f, f1, f2, f3, f4, f5);
			this.head.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.head.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.ore.rotateAngleY = f2 / 20.f;
			this.rightleg.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.rightarm.rotateAngleX = MathHelper.cos(f * 0.6662F + (float) Math.PI) * f1;
			this.leftleg.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.leftarm.rotateAngleX = MathHelper.cos(f * 0.6662F) * f1;
		}
	}
}
